/*
 * Synt_si5351.c
 *
 * Prject created: 28.03.2020 17:38:03
 * Author: R0AEK
 * Version - 1.4 beta
 */ 

/*
   EEPROM

00...01		 (    Si5351-master,     Si5351 4-!!!!)
02			  					1-
03			  				1-
04			  BFO_L					4-
08			   Si5351 160m	4- 
0C			   Si5351 80m	4-
10			   Si5351 40m	4-
14			   Si5351 30m	4-
18			   Si5351 20m	4-
1C			   Si5351 17m	4-
20			   Si5351 15m	4-
24			   Si5351 12m	4-
28			   Si5351 10m	4-
2C			  BFO_H					4-

*/

#include "Main.h"

/* */
uint8_t  data_8_EEPROM;										// 1-x      EEPROM

volatile unsigned char data_ADC_0	= 0;					//   ADC0
volatile unsigned char data_ADC_1	= 0;					//   ADC1
int old_S_metr_Value				= 0;					//-

unsigned int but_1_State			= 0;					//  FUNC  (0 - , 1 - )
unsigned int but_2_State			= 0;					//  PTT		(0 - , 1 - )
unsigned int but_3_State			= 0;					//  ATT/PRE	(0 - , 1 - )
unsigned int but_4_State			= 0;					//  LSB/USB	(0 - , 1 - )
unsigned int but_Count_Pressed		= 0;					//    
unsigned int but_Last_Cnt_Pres		= 0;					//-
unsigned int but_Last_Pres			= 0;					//   
unsigned int but_ATT_PRE			= 0;					//   ATT  PRE
unsigned int but_PTT_ON				= 0;					//  PTT
unsigned int but_LSB_USB			= 0;					//  LSB/USB	(0 - , 1 - )

volatile uint8_t next_state;								//     
volatile uint8_t prev_state;								//-
volatile uint8_t up_state;									//-
volatile uint8_t down_state;								//-

unsigned int ABCD_Code				= 0x00;					//  ABCD    

unsigned int func_Mode				= FUNC_MODE_NORMAL;		//    
char TempStr[10];											//      
unsigned char band_Num				= BAND_80m;				//   
uint32_t freq_BFO					= FREQ_BFO_L;			//  c  BFO    Hz
uint32_t freq_BFO_L					= FREQ_BFO_L;			//  c  BFO_L    Hz
uint32_t freq_BFO_H					= FREQ_BFO_H;			//  c  BFO_H    Hz
uint32_t freq_VFO					= 3600000;				//  c  VFO    Hz
															/*  */
const uint32_t band_F_BUFF[9]		= {1840000,3600000,7100000,10100000,14200000,18111000,21151000,24931000,28225000};
uint32_t freq_si					= 0;					//   c  Si5351  Hz
uint32_t old_freq_si				= 0;					//    Si5351
uint32_t calib_f_Si5351				= 0;					//     Si5351
															/*    	Si5351  EEPROM*/
const int band_EE_Addr[9]			= {0x08,0x0C,0x10,0x14,0x18,0x1C,0x20,0x24,0x28};
int set_Step						= 0;					//     
int set_Step_index					= 0;					//     
const int step_Value[6]				= {1,10,100,500,1000,10000};//   Hz
int set_Step_M						= 0;					//     
	
//  ---------------------------------------------------------------------------------------------------------------------/
void S_METR (void)											//   S-
{
	uint8_t a = 0;
		
	if (data_ADC_1 >= 1)  a = 0;	//S1
	if (data_ADC_1 >= 2)  a = 1;	//S3
	if (data_ADC_1 >= 3)  a = 2;	//S5
	if (data_ADC_1 >= 5)  a = 3;	//S7
	if (data_ADC_1 >= 9)  a = 4;	//S8
	if (data_ADC_1 >= 18) a = 5;	//S9
	if (data_ADC_1 >= 30) a = 6;	//S+10
	if (data_ADC_1 >= 50) a = 7;	//S+20
	
	if (old_S_metr_Value > a)
	{
		for(int i=8+old_S_metr_Value;i<16;i++)
		{
			LCD_set_pos(i,1);
			LCD_send_str(" ");
		}
	}
		
	old_S_metr_Value = a;
	LCD_set_pos(8,1);
	for(int b=0;b<a+1;b++)
	{
		if (b < 7)
		{
			LCD_send_char(b);
		}
		else	
			LCD_send_char(0xFF);	//S+20
	}
}

void SR_Write (char a)										//    
{
	ABCD_Code = a;					//    
	
	unsigned char i;
	for(i=0;i<8;i++)
	{
		/**/
		if(a & 0x80)
			PORTD |= (1<<SR_DATA);
		else
			PORTD &= ~(1<<SR_DATA);
		
		/**/
		asm("nop");
		PORTD |= (1<<SR_CLOCK);
		asm("nop");
		PORTD &= ~(1<<SR_CLOCK);
		a <<= 1;
	}
	
	/**/
	asm("nop");
	PORTD |= (1<<SR_LATCH);
	asm("nop");
	PORTD &= ~(1<<SR_LATCH);
}

void ATT_PRE (void)											//   ATT  PREAMP
{
	but_Count_Pressed = 0;
	
	if (but_ATT_PRE == 0)
	{
		SR_Write(ABCD_Code&~(1<<4));
		SR_Write(ABCD_Code&~(1<<5));
		LCD_set_pos(4,1);
		LCD_send_str("   ");
	}
	
	if (but_ATT_PRE == 1)
	{
		/*4     1*/
		SR_Write(ABCD_Code|1<<4);
		LCD_set_pos(4,1);
		LCD_send_str("ATT");
	}
	if (but_ATT_PRE == 2)
	{
		SR_Write(ABCD_Code&~(1<<4));
		/*5     1*/
		SR_Write(ABCD_Code|1<<5);
		LCD_set_pos(4,1);
		LCD_send_str("PRE");
	}
}

void PTT_ON (void)											//   TX
{
	but_PTT_ON = 1;
	func_Mode = FUNC_MODE_TX;
	/*6     1*/
	SR_Write(ABCD_Code|1<<6);
	LCD_set_pos(0,0);
	LCD_send_str("TX-ON");
	LCD_set_pos(4,1);
	LCD_send_str("            ");
}

void Mode_Label_To_LCD (void)								//     LCD
{
	/*  LSB/USB*/
	LCD_set_pos(0,1);
	if (band_Num <= BAND_40m)
	{
		if (but_LSB_USB == 0)
			LCD_send_str("USB");
		if (but_LSB_USB == 1)
			LCD_send_str("LSB");
	}
	else
	{
		if (but_LSB_USB == 0)
			LCD_send_str("LSB");
		if (but_LSB_USB == 1)
			LCD_send_str("USB");
	}
	
	ATT_PRE();
}

void Band_Label_To_LCD (void)								//     LCD
{
	/*    LCD*/
	LCD_set_pos(0,0);
	LCD_send_str("     ");
	LCD_set_pos(0,0);
	
	switch (band_Num)
	{
		case 1: 
			LCD_send_str("160m");
			break;
		case 2: 
			LCD_send_str("80m");
			break;
		case 3: 
			LCD_send_str("40m");
			break;
		case 4: 
			LCD_send_str("30m");
			break;
		case 5: 
			LCD_send_str("20m");
			break;
		case 6: 
			LCD_send_str("17m");
			break;
		case 7: 
			LCD_send_str("15m");
			break;
		case 8: 
			LCD_send_str("12m");
			break;
		case 9: 
			LCD_send_str("10m");
			break;
	}
	
	Mode_Label_To_LCD();
}

void Calc_Out_Freq_Si5351 (void)							//   Si5351
{
	/*if ((band_Num == BAND_160m)||(band_Num == BAND_80m)||(band_Num == BAND_40m))
		freq_si = freq_VFO + freq_BFO;
	if ((band_Num == BAND_30m)||(band_Num == BAND_20m)||(band_Num == BAND_17m)||(band_Num == BAND_15m)||(band_Num == BAND_12m)||(band_Num == BAND_10m))
		freq_si = freq_VFO - freq_BFO;*/
	
	freq_si = freq_VFO + freq_BFO;
	
	/*  */
	freq_si = freq_si - calib_f_Si5351;
}

void LSB_USB (void)											// LSB/USB
{
	but_Count_Pressed = 0;
	
	if (but_LSB_USB == 0)
	{
		but_LSB_USB = 1;
		/*7     1*/
		SR_Write(ABCD_Code|1<<7);
		if ((band_Num == BAND_160m)||(band_Num == BAND_80m)||(band_Num == BAND_40m))
			freq_BFO = freq_BFO_H;
		if ((band_Num == BAND_30m)||(band_Num == BAND_20m)||(band_Num == BAND_17m)||(band_Num == BAND_15m)||(band_Num == BAND_12m)||(band_Num == BAND_10m))
			freq_BFO = freq_BFO_L;
	}
	else
	{
		but_LSB_USB = 0;
		/*7     0*/
		SR_Write(ABCD_Code&~(1<<7));
		if ((band_Num == BAND_160m)||(band_Num == BAND_80m)||(band_Num == BAND_40m))
			freq_BFO = freq_BFO_L;
		if ((band_Num == BAND_30m)||(band_Num == BAND_20m)||(band_Num == BAND_17m)||(band_Num == BAND_15m)||(band_Num == BAND_12m)||(band_Num == BAND_10m))
			freq_BFO = freq_BFO_H;
	}
	
	Mode_Label_To_LCD();
}

void Freq_VFO_to_LCD (int d)								//    LCD
{
	unsigned char n = 0;
	
	if (d == 5) // MHz
	{
		for(n=0;n<=2;n++)
			LCD_send_char(TempStr[n]);
		LCD_send_char(46);
		for(n=3;n<=5;n++)
			LCD_send_char(TempStr[n]);
	}
	
	if (d == 1) // MHz
	{
		LCD_send_char(TempStr[0]);
		LCD_send_char(39);
		for(n=1;n<=3;n++)
			LCD_send_char(TempStr[n]);
		LCD_send_char(46);
		for(n=4;n<=6;n++)
			LCD_send_char(TempStr[n]);
	}
	
	if (d == 10) // MHz
	{
		LCD_send_char(TempStr[0]);
		LCD_send_char(TempStr[1]);
		LCD_send_char(39);
		for(n=2;n<=4;n++)
			LCD_send_char(TempStr[n]);
		LCD_send_char(46);
		for(n=5;n<=7;n++)
			LCD_send_char(TempStr[n]);
	}
}

void Read_Setup_EEPROM (void)								//   EEPROM
{
	/*   Hz*/
	data_8_EEPROM =  eeprom_read_byte((uint8_t*)0x02);
	if ((data_8_EEPROM >= 0)&&(data_8_EEPROM <= 5))			//     step_Value
		set_Step = step_Value[data_8_EEPROM];				//
	else //
	{
		set_Step = step_Value[3];							// 100 Hz
		eeprom_write_byte((uint8_t*)0x02, step_Value[3]);	//   EEPROM       step_Value
	}
	
	/*    */
	data_8_EEPROM =  eeprom_read_byte((uint8_t*)0x03);
	if ((data_8_EEPROM >= 1)&&(data_8_EEPROM <= 9))			//      BAND-of
		band_Num = data_8_EEPROM;							//
	else //
		eeprom_write_byte((uint8_t*)0x03,band_Num);			//     EEPROM
	
	/*  Freq_BFO_L  Hz*/
	freq_BFO_L = eeprom_read_float((float*)0x04);
	if (freq_BFO_L == 0)									//   = 0
	{	
		freq_BFO_L = FREQ_BFO_L;
		eeprom_write_float((float*)0x04,freq_BFO_L);		//  EEPROM   BFO_L  
	}
		
	/*  Freq_BFO_H  Hz*/
	freq_BFO_H = eeprom_read_float((float*)0x2C);
	if (freq_BFO_H == 0)									//   = 0
	{
		freq_BFO_H = FREQ_BFO_H;
		eeprom_write_float((float*)0x2C,freq_BFO_H);		//  EEPROM   BFO_H  
	}
		
	/*   Si5351  Hz*/
	calib_f_Si5351 = eeprom_read_float((float*)band_EE_Addr[band_Num - 1]);
}

void Step_Value_to_LCD (void)								//     LCD
{
	LCD_set_pos(0,1);
	LCD_send_str("        ");
	LCD_set_pos(0,1);
	if (set_Step < 1000)
	{
		itoa(set_Step,TempStr,10);
		LCD_send_str(TempStr);
		LCD_send_str(" Hz");
	}
	else
	{
		itoa(set_Step/1000,TempStr,10);
		LCD_send_str(TempStr);
		LCD_send_str(" kHz");
	}
}

void Change_STEP (int Value)								//   
{
	_delay_ms(10);
	for (int a=0;a<=5;a++)
	{
		if (set_Step == step_Value[a])
			set_Step_index = a;
	}
	
	if (Value == 1)
	{
		set_Step_index++;
		if (set_Step_index > 5)
			set_Step_index = 0;
		set_Step = step_Value[set_Step_index];
	}
	
	if (Value == 2)
	{
		set_Step_index--;
		if (set_Step_index < 0)
			set_Step_index = 5;
		set_Step = step_Value[set_Step_index];
	}
	
	Step_Value_to_LCD();
}

void Set_BFO (int Value)									//  BFO
{
	if (func_Mode == FUNC_MODE_SET_BFO_L)
	{
		if (Value == 1) freq_BFO_L = freq_BFO_L + set_Step;
		if (Value == 2)	freq_BFO_L = freq_BFO_L - set_Step;
		
		/*      */
		if (freq_BFO_L <= 100000)	  {freq_BFO_L = 100000; return;}
		if (freq_BFO_L >= 15000000) {freq_BFO_L = 15000000; return;}
		
		/*  BFO  */
		ultoa(freq_BFO_L,TempStr,10);
	}
	
	if (func_Mode == FUNC_MODE_SET_BFO_H)
	{
		if (Value == 1) freq_BFO_H = freq_BFO_H + set_Step;
		if (Value == 2)	freq_BFO_H = freq_BFO_H - set_Step;
		
		/*      */
		if (freq_BFO_H <= 100000)	  {freq_BFO_H = 100000; return;}
		if (freq_BFO_H >= 15000000) {freq_BFO_H = 15000000; return;}
		
		/*  BFO  */
		ultoa(freq_BFO_H,TempStr,10);
	}
	
	//  LCD
	//    9 999 999 Hz,   
	LCD_set_pos(6,1);
	if (freq_BFO_L <= 9999999)
	{
		if (freq_BFO_L <= 999999)
		{
			LCD_send_str("   ");
			Freq_VFO_to_LCD(5);
		}
		else
		{
			LCD_send_str(" ");
			Freq_VFO_to_LCD(1);
		}
	}
	else
		Freq_VFO_to_LCD(10);	
}

void Set_VFO (int Value)									//  VFO
{
	if (Value == 1) freq_si = freq_si + set_Step;
	if (Value == 2) freq_si = freq_si - set_Step;
	
	/*      */
	if (freq_si <= 1000000)  {freq_si = 1000000; return;}
	if (freq_si >= 29999999) {freq_si = 29999999; return;}
	
	/*   Si5351*/
	si5351aSetFrequency(freq_si);
	
	/*  VFO  */
	ultoa(freq_si,TempStr,10);
	_delay_ms(10);
	/*  LCD
	    9 999 999 Hz,   */
	LCD_set_pos(6,1);
	if (freq_si <= 9999999)
	{
		if (freq_si <= 999999)
			LCD_send_str("   ");
		else
			LCD_send_str(" ");
		Freq_VFO_to_LCD(1);
	}
	else
		Freq_VFO_to_LCD(10);
}
	
void Check_BAND (void)										//  
{
	int b = band_Num;
		
	/* ABCD     (   Q0...Q3)
	160m	= 0000
	80m		= 1000
	40m		= 0100
	30m		= 1100
	20m		= 0010
	17m		= 1010
	15m		= 0110
	12m		= 1110
	10m		= 0001
	  ABCD    */
	if ((freq_VFO >=FREQ_VFO_MIN)&&(freq_VFO <= BAND_1_MAX)) {band_Num = 1; SR_Write(0x00);}
	if ((freq_VFO > BAND_1_MAX)&&(freq_VFO <= BAND_2_MAX))	 {band_Num = 2; SR_Write(0x08);}
	if ((freq_VFO > BAND_2_MAX)&&(freq_VFO <= BAND_3_MAX))   {band_Num = 3; SR_Write(0x04);}
	if ((freq_VFO > BAND_3_MAX)&&(freq_VFO <= BAND_4_MAX))   {band_Num = 4; SR_Write(0x0C);}
	if ((freq_VFO > BAND_4_MAX)&&(freq_VFO <= BAND_5_MAX))   {band_Num = 5; SR_Write(0x02);}
	if ((freq_VFO > BAND_5_MAX)&&(freq_VFO <= BAND_6_MAX))   {band_Num = 6; SR_Write(0x0A);}
	if ((freq_VFO > BAND_6_MAX)&&(freq_VFO <= BAND_7_MAX))   {band_Num = 7; SR_Write(0x06);}
	if ((freq_VFO > BAND_7_MAX)&&(freq_VFO <= BAND_8_MAX))   {band_Num = 8; SR_Write(0x0E);}
	if ((freq_VFO > BAND_8_MAX)&&(freq_VFO <= FREQ_VFO_MAX)) {band_Num = 9; SR_Write(0x01);}
	
	/*   ATT  PRE*/
	ATT_PRE();
		
	if (freq_VFO > FREQ_VFO_MAX)
	{
		band_Num = BAND_160m;
		freq_VFO = FREQ_VFO_MIN;
	}
	
	if (freq_VFO < FREQ_VFO_MIN)
	{
		band_Num = BAND_10m;
		switch (set_Step)
		{
			case 1:									//
				freq_VFO = FREQ_VFO_MAX;
				break;
			case 10:								//
				freq_VFO = FREQ_VFO_MAX - 9;
				break;
			case 100:								//
				freq_VFO = FREQ_VFO_MAX - 99;
				break;
			case 500:								//
				freq_VFO = FREQ_VFO_MAX - 499;
				break;	
			case 1000:								//
				freq_VFO = FREQ_VFO_MAX - 999;
				break;
			case 10000:								// 
				freq_VFO = FREQ_VFO_MAX - 9999;
				break;
		}
	}
	
	/*   ,  */
	if (b != band_Num)
	{
		/*     EEPROM*/
		eeprom_write_byte((uint8_t*)0x03,band_Num);
		Band_Label_To_LCD();
	}
	
	/*   Si5351  Hz   */
	calib_f_Si5351 = eeprom_read_float((float*)band_EE_Addr[band_Num - 1]);
	Calc_Out_Freq_Si5351();
	/*   Si5351*/
	si5351aSetFrequency(freq_si);
}

void Calc_VFO (void)										//  VFO
{
	//  VFO    LCD    Si5351
	/*if ((band_Num == BAND_160m)||(band_Num == BAND_80m)||(band_Num == BAND_40m))
		freq_VFO = freq_si - freq_BFO;
	if ((band_Num == BAND_30m)||(band_Num == BAND_20m)||(band_Num == BAND_17m)||(band_Num == BAND_15m)||(band_Num == BAND_12m)||(band_Num == BAND_10m))
		freq_VFO = freq_si + freq_BFO;*/
	
	freq_VFO = freq_si - freq_BFO;
	
	/*  */
	freq_VFO = freq_VFO + calib_f_Si5351;
}

void Change_VFO (int Value)									//  
{
	if (Value==1) freq_si = freq_si + set_Step;
	if (Value==2) freq_si = freq_si - set_Step;
	
	/*   Si5351*/
	si5351aSetFrequency(freq_si);
	
	Calc_VFO();
	
	Check_BAND();
	
	//  VFO  
	ultoa(freq_VFO,TempStr,10);
	
	//    9 999 999 Hz,   
	LCD_set_pos(6,0);
	if (freq_VFO <= 9999999)
	{	
		LCD_send_str(" ");
		Freq_VFO_to_LCD(1);
	}
	else
		Freq_VFO_to_LCD(10);
	
}

void Set_BAND (void)										// 
{
	freq_VFO = band_F_BUFF[band_Num - 1];
	/*    Si5351  Hz  EEPROM*/
	calib_f_Si5351 = eeprom_read_float((float*)band_EE_Addr[band_Num - 1]);
	Calc_Out_Freq_Si5351();
	Change_VFO(0);
	Band_Label_To_LCD();
}

void Button_FUNC (void)										//   ADC0
{
	/***************   FUNC*****************/
	
	/*     FUNC   ,
	   */
	if ((but_Last_Pres == 1)&&(but_1_State == 1)&&(but_Last_Cnt_Pres > 5)&&(but_Last_Cnt_Pres < 50)&&(func_Mode == FUNC_MODE_NORMAL))
	{
		but_Last_Cnt_Pres = 0;
		band_Num++;
		if (band_Num > 9) band_Num = 1;
		if (band_Num < 1) band_Num = 9;
		/*     EEPROM*/
		eeprom_write_byte((uint8_t*)0x03,band_Num);
		/*  LSB/USB*/
		but_LSB_USB = 0;
		/*   */
		Set_BAND();
	}
	
	/*  (~1 )    FUNC   ,
	     */
	if ((but_Last_Pres == 1)&&(but_1_State == 1)&&(but_Last_Cnt_Pres > 50)&&(but_Last_Cnt_Pres < 150)&&(func_Mode == FUNC_MODE_NORMAL))
	{
		but_Last_Cnt_Pres = 0;
		func_Mode = FUNC_MODE_SET_STEP;					//  
		LCD_send_byte(0x01,0);							// 	
		LCD_set_pos(0,0);
		LCD_send_str("Select step");
		Step_Value_to_LCD();
	}
	
	/*     FUNC     
	          */
	if ((but_Last_Pres == 1)&&(but_1_State == 1)&&(but_Last_Cnt_Pres > 5)&&(but_Last_Cnt_Pres < 50)&&(func_Mode == FUNC_MODE_SET_STEP))
	{
		but_Last_Cnt_Pres = 0;
		eeprom_write_byte((uint8_t*)0x02, set_Step_index);		//  EEPROM        step_Value
		
		if (set_Step_M == 0)							//    
		{
			func_Mode = FUNC_MODE_NORMAL;				//  
			LCD_send_byte(0x01,0);						// 
			Change_VFO(0);
			Band_Label_To_LCD();
		}
		
		if (set_Step_M == 1)							//    BFO_L
		{
			func_Mode = FUNC_MODE_SET_BFO_L;			//   -  BFO_L
			LCD_send_byte(0x01,0);						// 
			LCD_set_pos(0,0);
			LCD_send_str("Set freq BFO_L");
			//  BFO_L  
			ultoa(freq_BFO_L,TempStr,10);
			//  LCD
			//    9 999 999 Hz,   
			LCD_set_pos(6,1);
			if (freq_BFO_L <= 9999999)
			{
				if (freq_BFO_L <= 999999)
				{
					LCD_send_str("   ");
					Freq_VFO_to_LCD(5);
				}
				else
				{
					LCD_send_str(" ");
					Freq_VFO_to_LCD(1);
				}
			}
			else
			Freq_VFO_to_LCD(10);
		}
		
		if (set_Step_M == 11)							//    BFO_H
		{
			func_Mode = FUNC_MODE_SET_BFO_H;			//   -  BFO_H
			LCD_send_byte(0x01,0);						// 
			LCD_set_pos(0,0);
			LCD_send_str("Set freq BFO_H");
			//  BFO_H  
			ultoa(freq_BFO_H,TempStr,10);
			//  LCD
			//    9 999 999 Hz,   
			LCD_set_pos(6,1);
			if (freq_BFO_H <= 9999999)
			{
				if (freq_BFO_H <= 999999)
				{
					LCD_send_str("   ");
					Freq_VFO_to_LCD(5);
				}
				else
				{
					LCD_send_str(" ");
					Freq_VFO_to_LCD(1);
				}
			}
			else
			Freq_VFO_to_LCD(10);
		}
		
		if (set_Step_M == 2)							//    VFO
		{
			func_Mode = FUNC_MODE_SET_VFO;				//   -  VFO
			LCD_send_byte(0x01,0);						// 
			LCD_set_pos(0,0);
			LCD_send_str("Calibration VFO");
			//  VFO  
			ultoa(freq_si,TempStr,10);
			//  LCD
			//    9 999 999 Hz,   
			LCD_set_pos(6,1);
			if (freq_si <= 9999999)
			{
				LCD_send_str(" ");
				Freq_VFO_to_LCD(1);
			}
			else
				Freq_VFO_to_LCD(10);
		}
	}
		
	/*  (~5 )    FUNC    ,
	    BFO_L*/
	if ((but_Last_Pres == 1)&&(but_1_State == 1)&&(but_Last_Cnt_Pres > 800)&&(but_Last_Cnt_Pres < 1000)&&(func_Mode == FUNC_MODE_NORMAL))
	{
		but_Last_Cnt_Pres = 0;
		func_Mode = FUNC_MODE_SET_BFO_L;				//   -  BFO_L
		LCD_send_byte(0x01,0);							// 	
		LCD_set_pos(0,0);
		LCD_send_str("Set freq BFO_L");		
		//  BFO  
		ultoa(freq_BFO_L,TempStr,10);
		//  LCD
		//    9 999 999 Hz,   
		LCD_set_pos(6,1);
		if (freq_BFO_L <= 9999999)
		{
			if (freq_BFO_L <= 999999)
			{
				LCD_send_str("   ");
				Freq_VFO_to_LCD(5);
			}
			else
			{	
				LCD_send_str(" ");
				Freq_VFO_to_LCD(1);
			}
		}
		else
			Freq_VFO_to_LCD(10);
	}
	
	/*     FUNC    BFO_L
	    BFO_H*/
	if ((but_Last_Pres == 1)&&(but_1_State == 1)&&(but_Last_Cnt_Pres > 5)&&(but_Last_Cnt_Pres < 50)&&(func_Mode == FUNC_MODE_SET_BFO_L))
	{
		but_Last_Cnt_Pres = 0;
		
		/*     freq_BFO_L*/
		if (but_LSB_USB == 0)
			freq_BFO = freq_BFO_L;
			
		func_Mode = FUNC_MODE_SET_BFO_H;				//   -  VFO
		eeprom_write_float((float*)0x04,freq_BFO_L);	//  BFO_L  EEPROM
		LCD_send_byte(0x01,0);							// 
		LCD_set_pos(0,0);
		LCD_send_str("Set freq BFO_H");
		//  BFO  
		ultoa(freq_BFO_H,TempStr,10);
		//  LCD
		//    9 999 999 Hz,   
		LCD_set_pos(6,1);
		if (freq_BFO_H <= 9999999)
		{
			if (freq_BFO_H <= 999999)
			{
				LCD_send_str("   ");
				Freq_VFO_to_LCD(5);
			}
			else
			{
				LCD_send_str(" ");
				Freq_VFO_to_LCD(1);
			}
		}
		else
		Freq_VFO_to_LCD(10);
	}
	
	/*     FUNC    BFO_H
	    VFO*/
	if ((but_Last_Pres == 1)&&(but_1_State == 1)&&(but_Last_Cnt_Pres > 5)&&(but_Last_Cnt_Pres < 50)&&(func_Mode == FUNC_MODE_SET_BFO_H))
	{
		but_Last_Cnt_Pres = 0;
		
		/*     freq_BFO_H*/
		if (but_LSB_USB == 1)
			freq_BFO = freq_BFO_H;
		
		func_Mode = FUNC_MODE_SET_VFO;					//   -  VFO
		eeprom_write_float((float*)0x2C,freq_BFO_H);	//  BFO_H  EEPROM
		freq_si = freq_si + calib_f_Si5351;				//   
		calib_f_Si5351 = 0;								//-
		/*   EEPROM*/
		eeprom_write_float((float*)band_EE_Addr[band_Num - 1],calib_f_Si5351);
		/*   Si5351*/
		si5351aSetFrequency(freq_si);
		old_freq_si = freq_si;							//     Si5351
		LCD_send_byte(0x01,0);							// 
		LCD_set_pos(0,0);
		LCD_send_str("Set freq VFO");
		//  VFO  
		ultoa(freq_si,TempStr,10);
		_delay_ms(10);
		//  LCD
		//    9 999 999 Hz,   
		LCD_set_pos(6,1);
		if (freq_si <= 9999999)
		{
			if (freq_si <= 999999)
				LCD_send_str("   ");
			else
				LCD_send_str(" ");
			Freq_VFO_to_LCD(1);
		}
		else
			Freq_VFO_to_LCD(10);
	}
	
	/*     FUNC    BFO_L/H   VFO,
	         BFO   VFO*/
	if ((but_Last_Pres == 1)&&(but_1_State == 1)&&(but_Last_Cnt_Pres > 50)&&(but_Last_Cnt_Pres < 150)&&((func_Mode == FUNC_MODE_SET_BFO_L)||(func_Mode == FUNC_MODE_SET_BFO_H)||(func_Mode == FUNC_MODE_SET_VFO)))
	{
		but_Last_Cnt_Pres = 0;
		
		if (func_Mode == FUNC_MODE_SET_BFO_L) set_Step_M = 1;
		if (func_Mode == FUNC_MODE_SET_BFO_H) set_Step_M = 11;
		if (func_Mode == FUNC_MODE_SET_VFO) set_Step_M = 2;
		
		func_Mode = FUNC_MODE_SET_STEP;					//  
		LCD_send_byte(0x01,0);							// 
		LCD_set_pos(0,0);
		LCD_send_str("Select step");
		Step_Value_to_LCD();
	}
		
	/*     FUNC    VFO
	    */
	if ((but_Last_Pres == 1)&&(but_1_State == 1)&&(but_Last_Cnt_Pres > 5)&&(but_Last_Cnt_Pres < 50)&&(func_Mode == FUNC_MODE_SET_VFO))
	{
		
		but_Last_Cnt_Pres = 0;
		if (func_Mode == FUNC_MODE_SET_VFO) set_Step_M = 0;
		calib_f_Si5351 = old_freq_si - freq_si;							//  
		eeprom_write_float((float*)band_EE_Addr[band_Num - 1],calib_f_Si5351);	//   EEPROM
		func_Mode = FUNC_MODE_NORMAL;									//  
		LCD_send_byte(0x01,0);											// 	
		Change_VFO(0);
		Band_Label_To_LCD();
	}
	
	/***************    PTT *****************/
	if ((but_Last_Pres == 3)&&(but_3_State == 1)&&(func_Mode == FUNC_MODE_TX))
	{
		but_Last_Cnt_Pres = 0;
		but_PTT_ON = 0;
		func_Mode = FUNC_MODE_NORMAL;
		/*6     0*/
		SR_Write(ABCD_Code&~(1<<6));
		Band_Label_To_LCD();
	}
}

void TIMER1_Init ()											// 16-  TC1
{
	TCCR1A = 0x00;					//normal   
	TCCR1B |= (1<<CS11);            //    8
	TCNT1H = 0x00;                  //    
	TCNT1L = 0x00;                  //    
	OCR1AH = 0x03;                  //    
	OCR1AL = 0xE8;                  //    
	TIMSK1 |= (1<<OCIE1A);			//      OCR1A
}

ISR (ADC_vect)												//   
{
	switch (ADMUX)
	{
		case 0x60:
			/*   ADC0*/
			data_ADC_0 = ADCH;					//     ADC0
			_delay_ms(1);
			if (data_ADC_0 == 255)				//  
			{
				_delay_ms(1);
				if (but_Count_Pressed > 0)
				{
					but_Last_Cnt_Pres = but_Count_Pressed;
					but_Count_Pressed = 0;		//     
				}
				but_1_State = 1;
				but_2_State = 1;
				but_3_State = 1;
				but_4_State = 1;
			}
			else
			{
				if ((data_ADC_0 >= 0)&&(data_ADC_0 < 5)) //0
				{
					but_1_State = 2;			// FUNC 
					but_Count_Pressed++;		//     
					but_Last_Pres = 1;
				}
				
				if ((data_ADC_0 > 100)&&(data_ADC_0 < 106)) //103
				{
					but_2_State = 2;			// ATT/PRE 
					but_Count_Pressed++;		//     
					but_Last_Pres = 2;
					if ((but_Count_Pressed > 1)&&(func_Mode == FUNC_MODE_NORMAL))
					{
						_delay_ms(75);
						but_ATT_PRE++;
						if (but_ATT_PRE > 2)
							but_ATT_PRE = 0;
						ATT_PRE();
					}
					return;
				}
				
				if ((data_ADC_0 > 139)&&(data_ADC_0 < 145)) //142
				{
					but_3_State = 2;			// PTT 
					but_Count_Pressed++;		//     
					but_Last_Pres = 3;
					if (func_Mode == FUNC_MODE_NORMAL)
						PTT_ON();
					return;
				}
				
				if ((data_ADC_0 > 157)&&(data_ADC_0 < 163)) //160
				{
					but_4_State = 2;			// LSB/USB 
					but_Count_Pressed++;		//     
					but_Last_Pres = 4;
					if ((but_Count_Pressed > 1)&&(func_Mode == FUNC_MODE_NORMAL))
					{
						_delay_ms(75);
						LSB_USB();
					}
					return;
				}
			}
			Button_FUNC();
			ADMUX = 0x61;
			break;
		case 0x61:
			/*   ADC1*/
			data_ADC_1 = ADCH;					//     ADC1
			if ((data_ADC_1 != 255)&&(func_Mode == FUNC_MODE_NORMAL)&&(but_1_State == 1)&&(but_2_State == 1)&&(but_3_State == 1))
				S_METR();
			ADMUX = 0x60;
			break;
		default:
			break;	
	}
}

ISR (TIMER1_COMPA_vect)										//  1
{
	next_state = PIND & ENCODER_MASK;	//   
	if (next_state != prev_state)
	{
		switch (prev_state)
		{
			case 8:
			{
				if (next_state == 12) up_state++;
				if (next_state == 0) down_state++;
				break;
			}
			case 0:
			{
				if (next_state == 8) up_state++;
				if (next_state == 4) down_state++;
				break;
			}
			case 4:
			{
				if (next_state == 0) up_state++;
				if (next_state == 12) down_state++;
				break;
			}
			case 12:
			{
				if (next_state == 4) up_state++;
				if (next_state == 8) down_state++;
				break;
			}
			default:
			{
				break;
			}
		}
		prev_state = next_state;    //   
	}
	TCNT1H = 0x00;					// 
	TCNT1L = 0x00;                  //-
}

// ------------------------------------------------------------------------------------------------------------/
int main(void)
{
	/* */
	DDRD  = 0xFF;											// D  
	PORTD = 0x4C;											//0b01001100 - 2  3 . .   , 6 . .   
	DDRB  = 0xFF;											// B  
	PORTB = 0x00;											//    B   0b00000000
	
	/*      
	 - ADMUX:   VCC,  ,  23 (ADC0)  */
	ADMUX = (0<<REFS1)|(1<<REFS0)|(1<<ADLAR)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0);
	
	/* - ADCSRA:  ,   OFF,     , 
	     ,    ,  CLK/128*/
	ADCSRA = (1<<ADEN)|(0<<ADSC)|(0<<ADATE)|(1<<ADIE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0);
		
	SR_Write(ABCD_Code|(0<<4)|(0<<5)|(0<<6));				//      PTT/ATT/PRE
	
	LCD_ini();												// 
	TIMER1_Init();											//  TC1   
	sei();													//  
	Read_Setup_EEPROM();									//   EEPROM

	/* I2C*/
	i2cInit();

	/*    Si5351*/
	si5351aSetFrequency(freq_si);
		
	func_Mode = FUNC_MODE_NORMAL;							//  
	Set_BAND();												//   
	Check_BAND();											//-
	LSB_USB();
	
	//  ------------------------------------------------------------------------------------------------------------/
	while (1)
	{	
		/*  ,        
		1   4        */
		if ((up_state >= 4)&&(but_1_State == 1)&&(but_2_State == 1)&&(but_3_State == 1))	// 
		{
			if (func_Mode == FUNC_MODE_NORMAL)
			{
				up_state = 0;
				Change_VFO(1);
			}
			if (func_Mode == FUNC_MODE_SET_STEP)
			{
				up_state = 0;
				Change_STEP(1);
			}
			if ((func_Mode == FUNC_MODE_SET_BFO_L)||(func_Mode == FUNC_MODE_SET_BFO_H))
			{
				up_state = 0;
				Set_BFO(1);
			}
			if (func_Mode == FUNC_MODE_SET_VFO)
			{
				up_state = 0;
				Set_VFO(1);
			}
		}
		if ((down_state >= 4)&&(but_1_State == 1)&&(but_2_State == 1)&&(but_3_State == 1))	// 
		{
			if (func_Mode == FUNC_MODE_NORMAL)
			{
				down_state = 0;
				Change_VFO(2);
			}
			if (func_Mode == FUNC_MODE_SET_STEP)
			{
				down_state = 0;
				Change_STEP(2);
			}
			if ((func_Mode == FUNC_MODE_SET_BFO_L)||(func_Mode == FUNC_MODE_SET_BFO_H))
			{
				down_state = 0;
				Set_BFO(2);
			}
			if (func_Mode == FUNC_MODE_SET_VFO)
			{
				down_state = 0;
				Set_VFO(2);
			}	
		}
		
		/*  */
		ADCSRA |= (1<<ADSC);
	}
}
//  ******************************************************************************************************/