/*
 * Main.h
 *
 * Created: 29.03.2020 23:14:50
 * Author: R0AEK
 */ 

#ifndef MAIN_H_
#define MAIN_H_

#define F_CPU 16000000UL

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <stdlib.h>

#include "Lcd_1602.h"
#include "si5351a.h"
#include "i2c.h"

#define FREQ_VFO_MAX			29999999				//   VFO  MHz
#define FREQ_VFO_MIN			1000000					//   VFO  MHz
#define FREQ_BFO_L				8867238					//    L  
#define FREQ_BFO_H				8870238					//    H  

#define ENCODER_MASK			0x0C					//      PD2  PD3 (0b00001100)

#define SR_CLOCK				PD4						//   -  
#define SR_DATA					PD5						//   -  
#define SR_LATCH				PD6						//   - 

#define FUNC_MODE_NORMAL		1						//  -  (RX)
#define FUNC_MODE_SET_STEP		2						//  -   
#define FUNC_MODE_SET_BFO_L		3						//  -   BFO_L
#define FUNC_MODE_SET_BFO_H		4						//  -   BFO_H
#define FUNC_MODE_SET_VFO		5						//  -   VFO
#define FUNC_MODE_TX			6						//  -  (TX)

#define BAND_160m				1						// 160m
#define BAND_80m				2						// 80m
#define BAND_40m				3						// 40m
#define BAND_30m				4						// 30m
#define BAND_20m				5						// 20m
#define BAND_17m				6						// 17m
#define BAND_15m				7						// 15m
#define BAND_12m				8						// 15m
#define BAND_10m				9						// 10m

#define BAND_1_MAX				2499999					// 
#define BAND_2_MAX				4499999					//-
#define BAND_3_MAX				7999999					//-
#define BAND_4_MAX				11999999				//-
#define BAND_5_MAX				15999999				//-
#define BAND_6_MAX				19999999				//-
#define BAND_7_MAX				23999999				//-
#define BAND_8_MAX				25999999				//-

#endif /* MAIN_H_ */